/* Esta funo realiza o clculo do envolvimento dos stakeholders no projeto para cada dia de monitoramento
@C:\Web_409\Sql\End_Conv\Oracle\9130_GEPFUNO_ATIV_REUNIAOPROJ.SQL
*/

CREATE OR REPLACE FUNCTION ATIV_REUNIAOPROJ
   (P_CDFILIAL   IN ITEMPRODUTO.CDFILIAL%TYPE,
    P_CDPROJETO  IN SOLISERV.NRSOLISERV%TYPE,
    P_DATAFIM    IN NOTAFISCAL.DTENTRSAID%TYPE) RETURN NUMBER
AS
   V_QTATIVCONC  ITEMPROIMPOS.VRBASECALCIT%TYPE;
   V_QTTOTATIV   ITEMPROIMPOS.VRBASECALCIT%TYPE;
BEGIN

    /* Atividades de reunio concludas at a data de monitoramento*/
    SELECT COUNT(*)
    INTO V_QTATIVCONC
    FROM TAREFA T, PLANATIVTARE P
    WHERE T.CDFILIAL   = P_CDFILIAL       AND
          T.CDPROJETO  = P_CDPROJETO      AND
          T.IDORIGTARE = '4'              AND
          T.CDFILIAL   = P.CDFILIAL       AND
          T.NRTAREFA   = P.NRTAREFA       AND
          P.IDSITATIVTAR = 'C'            AND
          TRUNC(P.DTCONATIVTAR) < P_DATAFIM;

    /* Nmero total de atividades de reunio*/
    SELECT COUNT(*)
    INTO V_QTTOTATIV
    FROM TAREFA T, PLANATIVTARE P
    WHERE T.CDFILIAL   = P_CDFILIAL       AND
          T.CDPROJETO  = P_CDPROJETO      AND
          T.IDORIGTARE = '4'              AND
          T.CDFILIAL   = P.CDFILIAL       AND
          T.NRTAREFA   = P.NRTAREFA       AND
          TRUNC(P.DTINCATIVTAR) < P_DATAFIM;

    IF V_QTTOTATIV = 0 THEN
       RETURN(0);
    ELSE
       RETURN((V_QTATIVCONC/V_QTTOTATIV)*100);
    END IF;
END;
/