/* Sistemas Integrados TECNISA

Nome: DTULTATU_ESTADOCONSERVA

Descrio:

Atualiza a data de ultima atualizao da tabela ESTADOCONSERVA

Criao:
15/01/2009 Frederico Gonalves Moreira da Costa
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ESTADOCONSERVA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ESTADOCONSERVA
GO

CREATE TRIGGER DTULTATU_ESTADOCONSERVA
ON ESTADOCONSERVA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ESTADOCONSERVA',NULL,'CDEMPRESA='+CDEMPRESA+';'+'CDTIPODEPREC='+CDTIPODEPREC+';',
                               GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ESTADOCONSERVA
      SET DTULTATUESTCON = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(REGIMEBEM.CDEMPRESA,0) = ISNULL(INSERTED.CDEMPRESA,0)) AND
            (ISNULL(REGIMEBEM.CDESTCONSERVA,0) = ISNULL(INSERTED.CDESTCONSERVA,0)) AND
            (ISNULL(REGIMEBEM.NMESTCONSERVA,0) = ISNULL(INSERTED.NMESTCONSERVA,0)) AND
            (ISNULL(REGIMEBEM.NMABREVESTCON,0) = ISNULL(INSERTED.NMABREVESTCON,0)) AND
            (ISNULL(REGIMEBEM.DSOBSESTCON,0) = ISNULL(INSERTED.DSOBSESTCON,0)) AND
            (ISNULL(REGIMEBEM.CDOPERATUESTCON,0) = ISNULL(INSERTED.CDOPERATUESTCON,0));
   END;
END;
GO